using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;

using Singleton.CVirusManager;

namespace CWorld
{
    public class CAttackingCell : ICell
    {
        public void determineAction(CCell thisCell, GameTime time)
        {
            // checks to see if the target is stil in range
            if (thisCell.inRange(CWorld.Game1.entityList[thisCell.CurrentTargetID].CurrentPosition, thisCell.EntityVision))
            {
                // checks to see if the target is still active
                if (CWorld.Game1.entityList[thisCell.CurrentTargetID].IsActive)
                {
                    // checks to see if the target is still attackable
                    if (CWorld.Game1.entityList[thisCell.CurrentTargetID].Attackable)
                    {
                        thisCell.determineDirection(CWorld.Game1.entityList[thisCell.CurrentTargetID].CurrentPosition);
                        thisCell.EntityDirection += thisCell.avoid();
                        return;
                    }
                }
            }

            // resets the entity to the roaming state with no target
            thisCell.CellBehaviour = new CRoamingCell();
            thisCell.CurrentTargetID = -1;
        }

        public void collisionResult(CCell thisCell, int otherEntityID)
        {
            // if a virus collides with this entity, it becomes an infecting cell
            if (CVirusManager.getInstance.isVirus(otherEntityID))
            {
                thisCell.CellBehaviour = new CInfectingCell();
                thisCell.Attackable = false;
                thisCell.CollisionValue = 0;
                thisCell.NumberOfViruses++;
            }
            else if(CWorld.Game1.entityList[otherEntityID].EntitySide != CWorldEntity.eSide.projectile)
            {
                thisCell.takeDamage(CWorld.Game1.entityList[otherEntityID].CollisionValue);
            }
        }
    }
}