﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

using Microsoft.Xna.Framework;
using Singleton.CCellManager;

namespace CWorld
{
    class CAttackingVirus : IVirus
    {
        public void determineAction(CVirus thisVirus, GameTime time)
        {
            // checks to see if the target is still in range
            if (thisVirus.inRange(CWorld.Game1.entityList[thisVirus.CurrentTargetID].CurrentPosition, thisVirus.EntityVision))
            {
                // checks to see if the target is still active
                if (CWorld.Game1.entityList[thisVirus.CurrentTargetID].IsActive)
                {
                    // checks to see if the target is still attackbale
                    if (CWorld.Game1.entityList[thisVirus.CurrentTargetID].Attackable)
                    {
                        thisVirus.determineDirection(CWorld.Game1.entityList[thisVirus.CurrentTargetID].CurrentPosition);
                        thisVirus.EntityDirection += thisVirus.avoid();
                        return;
                    }
                }
            }

            // resets the entity to the roaming state with no target
            thisVirus.VirusBehaviour = new CRoamingVirus();
            thisVirus.CurrentTargetID = -1;
        }

        public void collisionResult(CVirus thisVirus, int otherEntityID)
        {
            if (CCellManager.getInstance.isCell(otherEntityID))
            {
                thisVirus.IsActive = false;
            }
            else if(CWorld.Game1.entityList[otherEntityID].EntitySide != CWorldEntity.eSide.projectile)
            {
                thisVirus.takeDamage(CWorld.Game1.entityList[otherEntityID].CollisionValue);
            }
        }
    }
}
