﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

using Microsoft.Xna.Framework;
using Singleton.CCellManager;

namespace CWorld
{
    class CSpawnedVirus : IVirus
    {
        #region constructor
        public CSpawnedVirus(Vector2 direction)
        {
            spawnDirection = direction;
        }
        #endregion

        #region
        private Vector2 spawnDirection;

        public Vector2 SpawnDirection
        {
            get { return spawnDirection; }
            set { spawnDirection = value; }
        }
        #endregion

        public void determineAction(CVirus thisVirus, GameTime time)
        {
            if (thisVirus.StartSpawned + thisVirus.pSPAWNED_DELAY < time.TotalRealTime.TotalMilliseconds)
            {
                thisVirus.VirusBehaviour = new CRoamingVirus();
            }
            else
            {
                thisVirus.EntityDirection += spawnDirection;
                thisVirus.EntityDirection += thisVirus.avoid();
            }
        }

        public void collisionResult(CVirus thisVirus, int otherEntityID)
        {
            if (CCellManager.getInstance.isCell(otherEntityID))
            {
                thisVirus.IsActive = false;
            }
            else if(CWorld.Game1.entityList[otherEntityID].EntitySide != CWorldEntity.eSide.projectile)
            {
                thisVirus.takeDamage(CWorld.Game1.entityList[otherEntityID].CollisionValue);
            }
        }
    }
}
